
program info;

{$IFC UNDEFINED THINK_PASCAL}
	uses
		Types, QuickDraw, Events, Windows, Dialogs, Fonts, DiskInit, TextEdit, Traps,{}
		Memory, SegLoad, Scrap, ToolUtils, OSUtils, Menus, Resources, StandardFile,{}
		GestaltEqu, Files, Errors, Devices, QuickDrawText, TextUtils; {}
{$ENDC}

(**********************************************************************************)
(*}
{	                       "Info ??"}
{	                       }
{					           	by John Bray}
{	}
{	              Version 1.0 17 March 1996}
{*)
(**********************************************************************************)

{Ingemar thought this was a neat little program, and did the following:}
{ Ported it to Pascal.}
{ Added support for keyboard, so you can use arrow keys, ESC key, command-Q etc.}
{ Hide the menu bar.}
{ Doesn't paint over more than it needs, so at least the buttons don't flicker.}


{Pity to put in globals in a proram that has no globals before, but this really simplifies the "qd." problem.}
	var
		gScreenBounds: Rect;

{---------------------------------------------------------------------------------------------------}
{--------------------------------------------------------------------------------------- Inform_User}
	procedure Inform_User (index: Integer);

		var
			theString: Str255;
			ignore: Integer;

{ 	get the string from STR# resource ID 128}
	begin
		theString[0] := Char(0);	{ make sure it's empty to start with - just in case it fails}
		GetIndString(theString, 128, index);

		ParamText(theString, '', '', '');
		ignore := Alert(128, nil);	{ 128 is the ID of the ALRT resource}

	end; {Inform_User}
{---------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------- Place_Buttons}
	procedure Place_Buttons (theLeftPicture: PicHandle; theRightPicture: PicHandle; theEscPicture: PicHandle);
		var
			buttonRect: Rect;		{ 	Where we draw the PICT		}

	{ note: all these PICTs are 32x32 pixels}

{	Left button - bottom left of monitor}
	{	calculate the drawing frame co-ordinates}
	begin
		buttonRect.top := gScreenBounds.bottom - 32;
		buttonRect.left := 0;
		buttonRect.bottom := gScreenBounds.bottom;
		buttonRect.right := 32;
	{	set the clipping region in the window and draw the PICT}
		ClipRect(buttonRect);
		DrawPicture(theLeftPicture, buttonRect);

{	Right button - bottom right of monitor}
	{	calculate the drawing frame co-ordinates}
		buttonRect.top := gScreenBounds.bottom - 32;
		buttonRect.left := gScreenBounds.right - 32;
		buttonRect.bottom := gScreenBounds.bottom;
		buttonRect.right := gScreenBounds.right;
	{	set the clipping region in the window and draw the PICT}
		ClipRect(buttonRect);
		DrawPicture(theRightPicture, buttonRect);

{	Esc button - top left of monitor}
	{	calculate the drawing frame co-ordinates}
		buttonRect.top := 20;
		buttonRect.left := 0;
		buttonRect.bottom := 52;
		buttonRect.right := 32;
	{	set the clipping region in the window and draw the PICT}
		ClipRect(buttonRect);
		DrawPicture(theEscPicture, buttonRect);
	end; {Place_Buttons}
{---------------------------------------------------------------------------------------------------}
{---------------------------------------------------------------------------------- Display_the_PICT}
	procedure Display_the_PICT (var pictRect: Rect; thePicture: PicHandle; var theLeftPicture: PicHandle; var theRightPicture: PicHandle; var theEscPicture: PicHandle; var prevDrawRect: Rect);
		var
			drawRect: Rect;				{ 	Where we draw the PICT	}
			pictHeight, pictWidth: Integer;	{ 	used in calculating screen co-ordinates}
			insetHeight, insetWidth: Integer;{ 	used in calculating screen co-ordinates}
										{   Note:	the above 4 variables aren't strictly}
										{			necessary,  but they make the code }
										{			easier to read}

	begin
{	Blank the screen}
		drawRect := screenBits.bounds;
		ClipRect(drawRect);
		ForeColor(blackColor);
		PaintRect(prevDrawRect);

{ 	get PICT dimensions  (already loaded by "Get_Next_PICT")}
		pictHeight := pictRect.bottom - pictRect.top;
		pictWidth := pictRect.right - pictRect.left;

{ 	calculate the insets required to centralise it on the monitor}
		insetWidth := (gScreenBounds.right - pictWidth) div 2;
		insetHeight := (gScreenBounds.bottom - pictHeight) div 2;

{	calculate the drawing frame co-ordinates}
		drawRect.top := insetHeight;
		drawRect.left := insetWidth;
		drawRect.bottom := insetHeight + pictHeight;
		drawRect.right := insetWidth + pictWidth;

{	set the clipping region in the window and draw the PICT}
		ClipRect(drawRect);
		DrawPicture(thePicture, drawRect);

{Return the new position so it will be erased properly}
		prevDrawRect := drawRect;

		HUnlock(Handle(thePicture));
		ReleaseResource(Handle(thePicture));

		Place_Buttons(theLeftPicture, theRightPicture, theEscPicture);
	end; {Display_the_PICT}
{---------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------- Get_Next_PICT}
	function Get_Next_PICT (pictID: Integer; var pictRect: Rect; var thePicture: PicHandle): Boolean;
		var
			total, contig: LongInt;	{ total memory available,  largest contigous block}
{	Try to get the PICT resource	}
	begin
		Get_Next_PICT := false;

		thePicture := GetPicture(pictID);
		if (thePicture = nil) then
			Exit(Get_Next_PICT);	{ no more PICTS!!}

		MoveHHi(Handle(thePicture));
		HLock(Handle(thePicture));				{need to keep track of it for a while}
		pictRect := thePicture^^.picFrame;

		PurgeSpace(total, contig);{ check on memory}
		if (contig < 1000) then
			begin
				Inform_User(1);
			end; {"Memory is a little low"}

		Get_Next_PICT := true;
	end; {Get_Next_PICT}
{---------------------------------------------------------------------------------------------------}
{------------------------------------------------------------------------------------ Set_the_Screen}
	function Set_the_Screen (pictWindow: WindowPtr): Boolean;
{	open the window resource		}
	begin
		Set_the_Screen := true;		{if we have to abort, it is an error and we are done & finished}

		pictWindow := GetNewCWindow(128, nil, WindowPtr(-1));
		if (pictWindow = nil) then
			Exit(Set_the_Screen);

{ 	make the window fill the screen}
		SizeWindow(pictWindow, gScreenBounds.right, gScreenBounds.bottom, FALSE);
		MoveWindow(pictWindow, 0, 0, false);

		ShowWindow(pictWindow);
		SetPort(pictWindow);

{Hide the menu bar! This is the minimal way to do it, which is ok in a modal program like this.}
		RectRgn(pictWindow^.visRgn, gScreenBounds);

		Set_the_Screen := false; { ie: NOT done & finished			}
	end; {Set_the_Screen}
{---------------------------------------------------------------------------------------------------}
{-------------------------------------------------------------------------------------- Load_Buttons}
{ Receives the addresses of 3 PicHandles}
	function Load_Buttons (var theLeftPicture: PicHandle; var theRightPicture: PicHandle; var theEscPicture: PicHandle): Boolean;
{Take some advantage of Pascal :-)}
		function LoadThatPict (id: Integer): PicHandle;
			var
				h: PicHandle;
		begin
			h := GetPicture(id);
			if (h = nil) then
				Exit(Load_Buttons); { disaster - can't find resource!!}
			MoveHHi(Handle(h));
			HLock(Handle(h)); { we'll need this later on}
			LoadThatPict := h;
		end; {LoadThatPict}
{Here comes the main Load_Buttons}
	begin {Load_Buttons}
		Load_Buttons := true; {Error if we have to abort prematurely}

		theLeftPicture := LoadThatPict(1001); {Left button}
		theRightPicture := LoadThatPict(1002); {Right button}
		theEscPicture := LoadThatPict(1003); {Esc button}

		Load_Buttons := false; { ie: NOT done & finished	}
	end; {Load_Buttons}
{---------------------------------------------------------------------------------------------------}
{---------------------------------------------------------------------------------- Check_for_Events}
	function Check_for_Events (pictID: Integer; var theEvent: EventRecord; mouseRegion: RgnHandle; var pictRect: Rect; thePicture: PicHandle; theLeftPicture: PicHandle; theRightPicture: PicHandle; theEscPicture: PicHandle; var done: Boolean; var prevDrawRect: Rect): Integer;
		const
			kEsc = Char(27);
			kLeftArrow = Char(28);
			kRightArrow = Char(29);
			kUpArrow = Char(30);
			kDownArrow = Char(31);
		var
			buttonNotHit: Boolean;	{ unless a button is hit that we can do something about}
								{ there's nothing to be done.}

		procedure Right;
		begin
			pictID := pictID + 1;								{ try for the next PICT }
			if (Get_Next_PICT(pictID, pictRect, thePicture)) then	{ this call locks thePicture handle}
		  		 												{ if successful}
				begin
					buttonNotHit := false;
					HUnlock(Handle(thePicture));
					ReleaseResource(Handle(thePicture));
				end
			else
				begin
					pictID := pictID - 1;
					SysBeep(1);			{Hit the edge! Beep!}
				end;						{ put it back to where it was - nothing to do}
		end;
		procedure Left;
		begin
			if (pictID > 128) then
				begin
					pictID := pictID - 1;
					buttonNotHit := false;
				end
			else
				SysBeep(1);			{Hit the edge! Beep!}
		end;
		procedure Esc;
		begin
			done := true;
			Exit(Check_for_Events);
		end; { User wants to Quit}

	begin
		buttonNotHit := true;
		Check_for_Events := pictID;
		if WaitNextEvent(everyEvent, theEvent, 10, mouseRegion) then
			;

		if theEvent.what = keyDown then
			begin
				case Char(BitAnd(theEvent.message, charCodeMask)) of
					'.':  {Period: either right half of the 'comma and period' pair, or command-period,}
						if BitAnd(theEvent.modifiers, cmdKey) <> 0 then
							Esc
						else
							Right;
					kLeftArrow, '<', ',', '-': 
						Left;
					kRightArrow, '>', '+': 
						Right;
					kEsc: 
						Esc;
					'q', 'Q': {Q is valid only withthe command key.}
						if BitAnd(theEvent.modifiers, cmdKey) <> 0 then
							Esc;
					otherwise
				end; {case}
			end; {keyDown}

		if theEvent.what = mouseDown then
			begin
	{ 	OK: the user's clicked the mouse - let's find  out if a button was hit}

	{	Esc Button hit}
				if (theEvent.where.v >= 20) and (theEvent.where.v <= 52) and (theEvent.where.h >= 0) and (theEvent.where.h <= 32) then
					Esc;

	{	Left Button hit}
				if (theEvent.where.v >= gScreenBounds.bottom - 32) and (theEvent.where.v <= gScreenBounds.bottom) and (theEvent.where.h >= 0) and (theEvent.where.h < 32) then
					Left;

	{	Right Button hit}
				if (theEvent.where.v >= gScreenBounds.bottom - 32) and (theEvent.where.v <= gScreenBounds.bottom) and (theEvent.where.h >= gScreenBounds.right - 32) and (theEvent.where.h <= gScreenBounds.right) then
					Right;
			end; {mouseDown}

		Check_for_Events := pictID;
		if not buttonNotHit then
			if (Get_Next_PICT(pictID, pictRect, thePicture)) then{though this should be sure to succeed by now!}
				Display_the_PICT(pictRect, thePicture, theLeftPicture, theRightPicture, theEscPicture, prevDrawRect);

		Check_for_Events := pictID;
	end; {Check_for_Events}
{---------------------------------------------------------------------------------------------------}
{---------------------------------------------------------------------------- Initialise_Mac_Toolbox}
	procedure Initialise_Mac_Toolbox;
{	Initialize all the managers we need}
	begin
{$IFC UNDEFINED THINK_PASCAL}
		InitGraf(@qd.thePort);		{	we'll definitely need graphics}
		InitFonts; 				{ 	just in case there are some fonts in PICTS}
		FlushEvents(everyEvent, 0);	{ 	clean out any backlog of events}
		InitWindows;				{ 	can't get by without windows}
		InitMenus;				{	not really needed}
		TEInit;					{ 	not sure if this is needed - probably not}
		InitDialogs(nil);			{ 	for alerting user}

		gScreenBounds := qd.screenBits.bounds;
{$ELSEC}
		gScreenBounds := screenBits.bounds;
{$ENDC}
		InitCursor;				{	makes sure we get an arrow cursor}
	end; {Initialise_Mac_Toolbox}
{---------------------------------------------------------------------------------------------------}
{---------------------------------------------------------------------------------------------- main}

	var
		pictID: Integer; 			{ first PICT to display}
		done: Boolean;
		theEvent: EventRecord;				{ where we record the event}
		mouseRegion: RgnHandle;	{ region needed for call to "GetNextEvent"}
		pictRect: Rect;				{ The dimensions of the PICT}
		pictWindow: WindowPtr;				{ window where the picture is displayed}
		theLeftPicture, theRightPicture, theEscPicture: PicHandle;
		thePicture: PicHandle;
		appResFile: Integer;{ the application's resource file}
		prevDrawRect: Rect;

begin
	Initialise_Mac_Toolbox;

	pictID := 128; 			{ first PICT to display}
	done := false;
	mouseRegion := NewRgn;	{ region needed for call to "GetNextEvent"}
	appResFile := CurResFile;	{ the application's resource file}

	done := Set_the_Screen(pictWindow);
	if (done) then
		ExitToShell;

	done := Load_Buttons(theLeftPicture, theRightPicture, theEscPicture);
	if (done) then
		ExitToShell;

	prevDrawRect := gScreenBounds;

	{ make sure the first PICT is available and then display it}
	if (Get_Next_PICT(pictID, pictRect, thePicture)) then
		begin
			Display_the_PICT(pictRect, thePicture, theLeftPicture, theRightPicture, theEscPicture, prevDrawRect);
		end;

	repeat
		pictID := Check_for_Events(pictID, theEvent, mouseRegion, pictRect, thePicture, theLeftPicture, theRightPicture, theEscPicture, done, prevDrawRect);
	until done;

{Inform_User(2); {"That's all folks !!"}
end.
{------------------------------------------------------------------------------------------- THE END}